"""
    Adyen for Platforms: Account API

    The Account API provides endpoints for managing account-related entities on your platform. These related entities include account holders, accounts, bank accounts, shareholders, and KYC-related documents. The management operations include actions such as creation, retrieval, updating, and deletion of them.  For more information, refer to our [documentation](https://docs.adyen.com/platforms). ## Authentication To connect to the Account API, you must use basic authentication credentials of your web service user. If you don't have one, contact the [Adyen Support Team](https://support.adyen.com/hc/en-us/requests/new). Then use its credentials to authenticate your request, for example:  ``` curl -U \"ws@MarketPlace.YourMarketPlace\":\"YourWsPassword\" \\ -H \"Content-Type: application/json\" \\ ... ``` Note that when going live, you need to generate new web service user credentials to access the [live endpoints](https://docs.adyen.com/development-resources/live-endpoints).  ## Versioning The Account API supports versioning of its endpoints through a version suffix in the endpoint URL. This suffix has the following format: \"vXX\", where XX is the version number.  For example: ``` https://cal-test.adyen.com/cal/services/Account/v6/createAccountHolder ```  # noqa: E501

    The version of the OpenAPI document: 6
    Contact: developer-experience@adyen.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from adyen_account.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from adyen_account.exceptions import ApiAttributeError


def lazy_import():
    from adyen_account.model.vias_address import ViasAddress
    from adyen_account.model.vias_phone_number import ViasPhoneNumber
    globals()['ViasAddress'] = ViasAddress
    globals()['ViasPhoneNumber'] = ViasPhoneNumber


class StoreDetail(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('shopper_interaction',): {
            'ECOMMERCE': "Ecommerce",
            'POS': "POS",
        },
        ('status',): {
            'ACTIVE': "Active",
            'CLOSED': "Closed",
            'INACTIVE': "Inactive",
            'INACTIVEWITHMODIFICATIONS': "InactiveWithModifications",
            'PENDING': "Pending",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'address': (ViasAddress,),  # noqa: E501
            'merchant_account': (str,),  # noqa: E501
            'merchant_category_code': (str,),  # noqa: E501
            'store_reference': (str,),  # noqa: E501
            'full_phone_number': (str,),  # noqa: E501
            'phone_number': (ViasPhoneNumber,),  # noqa: E501
            'shopper_interaction': (str,),  # noqa: E501
            'split_configuration_uuid': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'store': (str,),  # noqa: E501
            'store_name': (str,),  # noqa: E501
            'virtual_account': (str,),  # noqa: E501
            'web_address': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'address': 'address',  # noqa: E501
        'merchant_account': 'merchantAccount',  # noqa: E501
        'merchant_category_code': 'merchantCategoryCode',  # noqa: E501
        'store_reference': 'storeReference',  # noqa: E501
        'full_phone_number': 'fullPhoneNumber',  # noqa: E501
        'phone_number': 'phoneNumber',  # noqa: E501
        'shopper_interaction': 'shopperInteraction',  # noqa: E501
        'split_configuration_uuid': 'splitConfigurationUUID',  # noqa: E501
        'status': 'status',  # noqa: E501
        'store': 'store',  # noqa: E501
        'store_name': 'storeName',  # noqa: E501
        'virtual_account': 'virtualAccount',  # noqa: E501
        'web_address': 'webAddress',  # noqa: E501
    }

    read_only_vars = {
        'status',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, address, merchant_account, merchant_category_code, store_reference, *args, **kwargs):  # noqa: E501
        """StoreDetail - a model defined in OpenAPI

        Args:
            address (ViasAddress):
            merchant_account (str): The merchant account to which the store belongs.
            merchant_category_code (str): The merchant category code (MCC) that classifies the business of the account holder.
            store_reference (str): Your unique identifier for the store, between 3 to 128 characters in length. This value will be shown as the store description in your Customer Area.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            full_phone_number (str): The phone number of the store provided as a single string.  It will be handled as a landline phone.  Examples: \"0031 6 11 22 33 44\", \"+316/1122-3344\", \"(0031) 611223344\". [optional]  # noqa: E501
            phone_number (ViasPhoneNumber): [optional]  # noqa: E501
            shopper_interaction (str): The sales channel. Possible values: **Ecommerce**, **POS**.. [optional]  # noqa: E501
            split_configuration_uuid (str): The unique reference for the split configuration, returned when you configure splits in your Customer Area. When this is provided, the `virtualAccount` is also required. Adyen uses the configuration and the `virtualAccount` to split funds between accounts in your platform.. [optional]  # noqa: E501
            status (str): The status of the store. Possible values: **Pending**, **Active**, **Inactive**, **InactiveWithModifications**, **Closed**.. [optional]  # noqa: E501
            store (str): Adyen-generated unique alphanumeric identifier (UUID) for the store, returned in the response when you create a store. Required when updating an existing store in an `/updateAccountHolder` request.. [optional]  # noqa: E501
            store_name (str): The name of the account holder's store, between  3 to 22 characters in length. This value will be shown in shopper statements.. [optional]  # noqa: E501
            virtual_account (str): The account holder's `accountCode` where the split amount will be sent. Required when you provide the `splitConfigurationUUID`.. [optional]  # noqa: E501
            web_address (str): URL of the ecommerce store.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.address = address
        self.merchant_account = merchant_account
        self.merchant_category_code = merchant_category_code
        self.store_reference = store_reference
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, address, merchant_account, merchant_category_code, store_reference, *args, **kwargs):  # noqa: E501
        """StoreDetail - a model defined in OpenAPI

        Args:
            address (ViasAddress):
            merchant_account (str): The merchant account to which the store belongs.
            merchant_category_code (str): The merchant category code (MCC) that classifies the business of the account holder.
            store_reference (str): Your unique identifier for the store, between 3 to 128 characters in length. This value will be shown as the store description in your Customer Area.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            full_phone_number (str): The phone number of the store provided as a single string.  It will be handled as a landline phone.  Examples: \"0031 6 11 22 33 44\", \"+316/1122-3344\", \"(0031) 611223344\". [optional]  # noqa: E501
            phone_number (ViasPhoneNumber): [optional]  # noqa: E501
            shopper_interaction (str): The sales channel. Possible values: **Ecommerce**, **POS**.. [optional]  # noqa: E501
            split_configuration_uuid (str): The unique reference for the split configuration, returned when you configure splits in your Customer Area. When this is provided, the `virtualAccount` is also required. Adyen uses the configuration and the `virtualAccount` to split funds between accounts in your platform.. [optional]  # noqa: E501
            status (str): The status of the store. Possible values: **Pending**, **Active**, **Inactive**, **InactiveWithModifications**, **Closed**.. [optional]  # noqa: E501
            store (str): Adyen-generated unique alphanumeric identifier (UUID) for the store, returned in the response when you create a store. Required when updating an existing store in an `/updateAccountHolder` request.. [optional]  # noqa: E501
            store_name (str): The name of the account holder's store, between  3 to 22 characters in length. This value will be shown in shopper statements.. [optional]  # noqa: E501
            virtual_account (str): The account holder's `accountCode` where the split amount will be sent. Required when you provide the `splitConfigurationUUID`.. [optional]  # noqa: E501
            web_address (str): URL of the ecommerce store.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.address = address
        self.merchant_account = merchant_account
        self.merchant_category_code = merchant_category_code
        self.store_reference = store_reference
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
